BCDPM:    MOV A,R2                      ; THIS ADDS OR SUBSTRACTS BCD MAPS.
          MOV R0,A                      ; R2 IS MAP 1 IF POL - BCDSB IF POL + BCDAD
          MOV A,@R0                     ; READ POLARITY OF MAP1.
          JNZ BCDSB                     ; IF NZ POL IS - THEN SUBSTRACT.
BCDAD:    CLR C                         ; AS IT IS ZERO POLARITY ADD.
          MOV R6,#0                     ; SET R6=0 AS IT IS USED IN THIS.
          MOV R7,#DVMNO                 ; SET R7 TO 4.
ADBCD:    MOV A,R7                      ; ADD DB AND PV.
          ADD A,R2                      ; ADD R7 TO ###MP TO GET UNITS, TENS PLACE ... WRT R7
          MOV R0,A                      ; UNITS PLACE OF R2MP 1ST LOOP TENS 2ND LOOP HUN-3,THO-4
          MOV A,R7                      ; AS R7 DEC IN DJNZ UNITS TENS HUN.
          ADD A,R4                      ; ADD R4MP TO GET U/T/H/T ETC ON CONSEC LOOPS.
          MOV R1,A                      ; UNITS PLACE OF R4MP
          MOV A,@R0                     ; READ UNITS PLACE OF R2MP 1ST LOOP.
          ADD A,R6                      ; ADD CARRY IN R6 TO ACC.
          MOV R6,#0                     ; RESET R6 FOR NEXT DIGIT OR IT WILL BE 1 FOR ALL.
          ADD A,@R1                     ; NOW ADD UNITS PLACE OF R4MP. FOR UNITS PLACE C=0
          DA A                          ; DECIMAL ADJUST A OVERFLOW IN UPPER NIBBLE..
          ADD A,#0F0H                   ; TO PUMP OUT A CARRY AS UPPER NIBBLE HAS CARRY.
          JC R6CL1                      ; IF CARRY IS SET STORE IT IN R6
          JMP R6C2L                     ; IF CARRY NOT SET JUMP OVER.
R6CL1:    MOV R6,#1                     ; SET R6 TO 1 TO INDICATE CARRY
          CLR C                         ; CLEAR CARRY AS CARRY IS STORED IN R6.
R6C2L:    ANL A,#0FH                    ; TO LOSE THE UPPER NIBBLE.
          MOV R0,A                      ; ACC HAS SUM AND CARRY IS ADDED TO NEXT DGT.
          MOV A,R7                      ; STORE RESULT TEMPORARILY IN R0.SET A TO R7 4,3,2,1 LOOP
          ADD A,R5                      ; WHEN R7=4 4+SD#MP IS UNITS POSITION
          MOV R1,A                      ; SET POINTER R1 TO ACC VALUE OR TMPMP UNITS LOC.
          MOV A,R0                      ; READ SAVED ACC VALUE OF SUM.
          MOV @R1,A                     ; WRITE TO TMPMP UNITS LOCATION CARRY MAY BE SET.
          DJNZ R7,ADBCD                 ; LOOP BACK TENS/HUNDS/THOUS AND ADD WITH CARRY.
          JMP BCDRT                     ; AS ADDITION IS OVER RETURN
BCDSB:    MOV A,R2                      ; DETERMIN R2MP>R4MP THEN R2MP-R4MP IF R4MP> R2MP THEN
          MOV R0,A                      ; SET R0 TO R2MP POL POSITION FOR COMPARISON.
          MOV A,R4                      ; R4MP IS SET TO R1
          MOV R1,A                      ; COMPARE R0 AND R1 IN SWPTS.
          MOV R7,#DVMNO                 ; MOV R7 TO 4 TO LOOP DJNZ FOR COMAPRING PV AND SP.
SWPTS:    INC R0                        ; GO TO THOUSANDS PLACE OF R2MP.
          INC R1                        ; K PLACE OF R4MP.
          MOV A,@R0                     ; READ K,H,T,U IN THAT ORDER OF R2MP INTO ACC AS IT LOOPS.
          XRL A,@R1                     ; COMPARE WITH CORRESPONDING PLACE IN R4MP.
          JNZ NEGAT                     ; IF MISMATCH DESISON TO SWAP CAN BE TAKEN NOW.
          DJNZ R7,SWPTS                 ; IF ZERO BOTH HAD SAME VALUE HENCE NEXT DIGITLOOP.
          JMP SWAPS                     ; VALUES ARE MATCHED HENCE SWAP.
NEGAT:    CLR C                         ; CARRY IS CLEARED AS ITS RESULT IS USED NOW.
          MOV A,@R0                     ; READ MISMATCHED PLACE OF R2MP TO ACC.
          CPL A                         ; R2MP-R4MP OF THAT DIGIT PERFORMED SUBSTRACION.
          ADD A,@R1                     ; X-Y, X TO ACC CPL A ADD Y TO ACC CPL A A = X-Y.
          JC SWAPS                      ; IF CARRY WAS SET SET R2MP POL + AND SWAP R2MP AND R4MP
          JMP NOSWP                     ; IF CARRY NOT SET R2MP AND R5MP ARE NOT SWAPPED.
SWAPS:    MOV A,R2                      ; SET POLARITY OF CNTMP POSITIVE.
          MOV R0,A                      ; SET POINTER R0 TO R2MP POLPOSITION.
          MOV @R0,#0                    ; SET POL POSITIVE.
          MOV A,R2                      ; IF CARRY WAS SET SWAP R2 AND R4 MAPS.
          XCH A,R4                      ; EXCHANGE R2 AND R4 VALUES.
          MOV R2,A                      ; ACC HAS R4MP PUT IN R2.
NOSWP:    CLR C                         ; BCD SUBSTRACTION OF R2MP - R4MP
          MOV R6,#0                     ; SET R6=0 AS IT IS USED IN THIS.
          MOV R7,#DVMNO                 ; SET R7 TO 4.
SBBCD:    MOV A,R7                      ; ACC TO 4,3,2,1 AS IT LOOPS.
          ADD A,R2                      ; ADD TO R2MP TO GET UNITS PLACE 1ST LOOP TENS 2.
          MOV R0,A                      ; UNITS PLACE OF R2MP 1ST LOOP TENS 2ND LOOP HUN-3,THO-4
          MOV A,R7                      ; AS R7 DEC IN DJNZ UNITS TENS HUN.
          ADD A,R4                      ; ADD R4MP POL POS TO GET U/T/H/T ETC ON CONSEC LOOPS.
          MOV R1,A                      ; UNITS PLACE OF R4MP
          MOV A,@R0                     ; READ UNITS PLACE OF R2MP.
          CPL A                         ; COMPLIMENT ACC.
          ADD A,R6                      ; ADD BORROW IN R6 TO ACC.
          MOV R6,#0                     ; RESET R6 FOR NEXT DIGIT OR IT WILL BE 1 FOR ALL.
          JNC CRYNO                     ; IF CARRY NOT SET CONTINUE AT CRYNO.
          ADD A,@R1                     ; ADD FROM UNITS PLACE OF R4MP CARRY IS LOST.
          CLR C                         ; CLEAR CARRY.
          CPL C                         ; COMPLIMENT CARRY TO RESTORE LOST CARRY.
          JMP CPLAP                     ; JUMP OVER TO CPLAP.
CRYNO:    ADD A,@R1                     ; ADD FROM UNITS PLACE OF R4MP.
CPLAP:    CPL A                         ; COMPLIMENT AGAIN.
          JC TNADD                      ; IF CARRY IS SET ADD TEN TO ACC.
          JMP NOTDO                     ; CARRY WAS NOT SET JUMPOVER.
TNADD:    CLR C                         ; CLEAR CARRY.
          ADD A,#10                     ; ADD 10 TO ACC.
          JC R6CL2                      ; IF CARRY IS SET STORE IT IN R6
          JMP NOTDO                     ; IF CARRY NOT SET JUMP OVER.
R6CL2:    MOV R6,#1                     ; SET R6 TO 1 TO INDICATE CARRY
          CLR C                         ; CLEAR CARRY AS CARRY IS STORED IN R6.
NOTDO:    MOV R0,A                      ; ACC HAS DIFF AND CARRY IF SET AGAIN IS BORROW.
          MOV A,R7                      ; STORE RESULT TEMPORARILY IN R0.SET A TO R7 4,3,2,1 LOOP
          ADD A,R5                      ; WHEN R7=4 4+SD#MP IS UNITS POSITION
          MOV R1,A                      ; SET POINTER R1 TO ACC VALUE OR TMPMP UNITS LOC.
          MOV A,R0                      ; READ SAVED ACC VALUE OF DIFF.
          MOV @R1,A                     ; WRITE TO TMPMP UNITS LOCATION DIFF MAY BE SET.
          DJNZ R7,SBBCD                 ; LOOP BACK TENS/HUNDS/THOUS AND SUB WITH BORROW.
BCDRT:    RET                           ; ADDITION OR SUBSTARCTION OVER.
                                        ;
MPSET:    MOV R0,#KEYPR                 ; ASSIGN R0 TO KEYPR.
          MOV A,@R0                     ; READ KEYPR.
          JB4 INCKY                     ; JUMP TO INCKY IF ACC BIT 4 IS SET.
          JB6 DECKY                     ; JUMP TO DECKY IF ACC BIT 6 IS SET.
          JMP MPRET                     ; KEY SERVED.
INCKY:    MOV A,R2                      ; READ POL PLACE IN R2.
          MOV R0,A                      ; WRITE IT TO R0.
          MOV A,@R0                     ; READ POLARITY.
          JNZ KYDEC                     ; IF ACC NON ZERO IT MEANS NEG JUMP TO KYDEC
KYINC:    MOV A,@R1                     ; READ LOC UNITS OF SELECTED MAP TO ACC.
          XRL A,#09H                    ; XOR ACC WITH 9, XOR IS A DATA COMPARATOR.
          JNZ INCRE                     ; IF DATA IN LOC 97 WAS 9 ACC NOW IS ZERO. JMP ON NZ.
          MOV @R1,#00H                  ; IF ACC WAS 0, 9 IN LOC 97 RESET TO 0.
          DEC R1                        ; SELECT LOC 96..93 TIL DJNZ IS OVER.
          DJNZ R7,KYINC                 ; DEC R7 AND CHECK FOR JUMP TO INCIT LOOP BACK IF NZ.
          MOV A,R2                      ; READ SAFE POLARITY POSITION.
          MOV R0,A                      ; WRITE INTO R0.
          MOV A,@R0                     ; READ POLARITY OF MAP.
          JNZ REFIX                     ; JUMP OVER TO REFIX IF NEGATIVE.
UPLMT:    MOV A,@R1                     ; R1 IN THOUSANDS PLACE AS DEC R1 BROUGHT IT THERE.
          JNZ REFIX                     ; IF THOUSANDS PLACE IS 1 IE 1999 OVER TO REFIX.
          INC @R1                       ; IF NOT IT WAS 0999 NOW 1000 AND RETURN.
          JMP MPRET                     ; AS IT HAS REACHED LIMIT 0999 OR GO TO 1000.FAST RTN
REFIX:    MOV A,R4                      ; GET SAFE STORAGE OF R7.
          MOV R7,A                      ; LOAD TO R7 THIS IS BECAUSE DJNZ CHANGES R7.
REPUT:    INC R1                        ; INCREMENT TO HUND POSITION/TEN/UNIT.
          MOV @R1,#9                    ; LOAD 9 RESTORE AS IT WAS MADE 0 BEFORE.
          DJNZ R7,REPUT                 ; LOOP TILL 1999 OR 999 COUNT IS RESTORED.
          JMP MPRET                     ; AS IT HAS RECAHED LIMIT 1999 OR 999 STOP.RTN SLOW
INCRE:    INC @R1                       ; INCREMENT RAM LOC ADDR BY R1.
INCCL:    JMP ZECHK                     ; CHECK IF REACHED 0.
DECKY:    MOV A,R2                      ; READ POL PLACE IN R2.
          MOV R0,A                      ; WRITE IT TO R0.
          MOV A,@R0                     ; READ POLARITY.
          JNZ KYINC                     ; IF ACC NON ZERO IT MEANS NEG JUMP TO KYDEC
KYDEC:    MOV A,@R1                     ; READ LOC UNITS OF SELECTED MAP TO ACC.
          XRL A,#00H                    ; XOR ACC WITH 9, XOR IS A DATA COMPARATOR.
          JNZ DECRE                     ; IF DATA IN LOC 97 WAS 9 ACC NOW IS ZERO. JUMP ON NZ.
          MOV @R1,#09H                  ; IF ACC WAS 0, 9 IN LOC 97 RESET TO 0.
          DEC R1                        ; SELECT LOC 96..93 TIL DJNZ IS OVER.
          DJNZ R7,KYDEC                 ; DEC R7 AND CHECK FOR JUMP TO INCIT LOOP BACK IF NZ.
          MOV A,@R1                     ; R1 IN THOUSANDS PLACE AS DEC R1 BROUGHT IT THERE.
          JZ REMAK                      ; IF THOUSNADS PLACE IS 0 IE 0999 OVER TO REMAK
          MOV @R1,#0                    ; IF NOT IT IS 1999 CHANGE 1 TO 0.
          JMP MPRET                     ; AS A DECREMENT HAS BEEN DONE 1000 TO 0999.
REMAK:    MOV A,R4                      ; GET SAFE STORAGE OF R7.
          MOV R7,A                      ; LOAD TO R7 THIS IS BECAUSE DJNZ CHANGES R7.
NOLIT:    INC R1                        ; INCREMENT TO HUND POSITION/TEN/UNIT.
          MOV @R1,#0                    ; PUT HUND POS TO 0 AS IT IS 9.
          DJNZ R7,NOLIT                 ; DUMP 0 IN H/T/U POSITIONS.
          JMP ZECHK                     ; CHANGE POLARITY AS IT HAS REACHED 0.
DECRE:    MOV A,@R1                     ; READ LOC.
          DEC A                         ; DEC IT.
          MOV @R1,A                     ; WRITE BACK.
ZECHK:    MOV A,R4                      ; GET SAFE STORAGE OF R7.
          INC A                         ; INCREMENT A BY ONE AS 19/1999 MAKES 1+1 OR 3+1 DGTS.
          MOV R7,A                      ; LOAD TO R7 THIS IS BECAUSE DJNZ CHANGES R7.
          MOV A,R5                      ; READ UNALTERED MAP DATA.
          MOV R1,A                      ; REFRESH DECREMENTED MAP IN R1.
          CLR A                         ; CLEAR ACC TO COMPARE WITH OTHERS.
ZECHL:    ORL A,@R1                     ; CHECK IF COUNT REACHED 0000 IF SO CHANGE POL (R0)
          DEC R1                        ; DECREMENT RAM LOC ADDR - R1.
          DJNZ R7,ZECHL                 ; READ ALL LOC AND CHECK FOR NON ZERO.
          JZ CPLPO                      ; IF ACC IS ZERO THEN COMPLIMENT POLARITY.
          JMP MPRET                     ; JUMP TO CLOSE.
CPLPO:    MOV A,R2                      ; READ POL PLACE IN R2.
          MOV R0,A                      ; WRITE IT TO R0.
          MOV A,@R0                     ; ACC CONTAINS VALUE FOR POLARITY 1 FOR NEG.
          JZ NECPL                      ; IF ZERO SET LOC TO 1.
          MOV @R0,#0                    ; IF NOT ZERO MOVE 0 TO COMPLIMENT.
          JMP MPRET                     ; KEY SERVED IN RAMP UP MODE.
NECPL:    MOV @R0,#1                    ; IF POL ZERO + CHANGE TO NEG BY FILLING 1.
MPRET:    RET                           ; RETURN TO REACT TO RMPSRV
