TICKS:    EQU 103                     ; LOCATION IN RAM FOR "TCEXT" ROTINE IN TCINT.
TRATE:    EQU 245                     ; HOLDS DEFAULT OF HICAL ON RAM FAIL OF NO CAL.
FLAG2:    EQU 114                     ; IS SET IN REDSP AFTR FLAG1 IS CLD TO STRT CNT IN SYNC.
GATER:    EQU 113                     ; LOCATION OF SAMPLE TIME = HICUL ON RELOAD.
HICAL:    EQU 76                      ; LOWER VALUE OF 16 BIT GATER FOR A/D SET IN CAL.
HICUL:    EQU 75                      ; HIGHER OF 16 BIT GATER FOR A/D SET IN CAL.
GATRT:    EQU 3                       ; HOLDS DEFAULT OF HICUL ON RAM FAIL OF NO CAL.
TIMES:    EQU 102                     ; LOCATION IN RAM FOR "TIMER" ROTINE IN TCINT.
SRATE:    EQU 1                       ; ONE DISPLAY LINE TAKES 6MS, 6*5 30MS IS KEY SCAN RAT
LNGTM:    EQU 110                     ; A LONG TIME BASE DEC EVERY 300MS UPTO 255*300MS MAX.
LRATE:    EQU 60                      ; LONG TIME PRESET RATE TIME FOR NORMALIZING SYSTEM.
RAMPS:    EQU 111                     ; THIS IS RAM LOCATION FOR THE RAMP SPEED 1 IS FAST.
SLOWS:    EQU 100                     ; THIS IS THE SLOWEST SPEED DEFAULT KEY RTN.
FASTS:    EQU 30                      ; THIS IS THE SLOWEST RAMP SPEED KEY RTN.
PRKEY:    EQU 01010000B               ; KEY COMBINATION OF PRG MODE.
CLKEY:    EQU 10100000B               ; KEY COMBINATION OF CAL MODE.
IOMSK:    EQU 0F0H                    ; SETS LOWER NIBBLE OF P2 FOR 4 KEYS.UPPER FOR 4 RLYS.
BOUNC:    EQU 2                       ; NO OF READS BEFRE AN EVENT IS ACCEPTED BOTH KEY/EXT
KEYPR:    EQU 109                     ; LOCATION HOLDS A DEBOUNCED VALID KEY PRESS.
KEYRT:    EQU 108                     ; HOLDS THE NO OF TIMES KEY PRESS VERIFIED.
TEMKY:    EQU 112                     ; HOLDS THE TEMPORARY KEY PRESS DURING KEY READ.
CALRN:    EQU 42                      ; IF 1 THEN IN RUNMODE CALIBRATION MODE IF ONLT T0=1.
PRGRN:    EQU 107                     ; IN PROG MODE VALUE 10000000B (LED) IN RUN MODE 0.
DISPL:    EQU 104                     ; HOLDS A COUNTER 0,1,2,3,4 MAPS TO PV,SP1,DB1,SP2,DB2
MAXDS:    EQU 5                       ; LIMITS ABOVE DISPL TO 5 IN CASE OF ABOVE. IF 1SP EQ3
TXT01:    EQU 126                     ; LOCATION OF CHARACTER CODE FOR 1 ALPHABET DISPLAY.
TXT02:    EQU 127                     ; LOCATION OF CHARACTER CODE FOR 2 ALPHABET DISPLAY.
DPSET:    EQU 65                      ; HOLDS THE DSPNO IN WHICH DP IS TO BE SET.
CNTMP:    EQU 97-DVMNO                ; STORAGE AREA OF COUNTER FOR INT. COUNTER."SUBROT".
CNTST:    EQU 97                      ; STORAGE END COUNTER FOR INT. COUNTER."SUBROT".
PRVMP:    EQU 40-DVMNO                ; PROCESS VALUE FROM A/D LATEST FIXED VALUE.
PRVST:    EQU 40                      ; STORAGE END OF PROCESS VALUE.
SD1MP:    EQU 119-DVMNO               ; STORAGE OF SP1 +/- DB1 VALUE.
SD2MP:    EQU 125-DVMNO               ; STORAGE OF SP2 +/- DB2 VALUE.
ADDMP:    EQU 101-DVMNO               ; USED AS A TEMPORARY STORAGE FOR BCD ADD SUBSTRACT.
SP1MP:    EQU 47-DVMNO                ; MAP OF SP1 VALUES 4 DIGITS AND POL.
DB1MP:    EQU 53-DVMNO                ; 0-9 LOC FOR DEADBAND 1.
SP2MP:    EQU 71-DVMNO                ; MAP OF SP2 VALUES 4 DIGITS AND POL.
DB2MP:    EQU 90-DVMNO                ; 0-9 LOC FOR DEADBAND 2.
ZERMP:    EQU 85-DVMNO                ; STORAGE AREA OF ZERO OFFSET FOR CALIBRATION.
DSPST:    EQU 63                      ; BANK1:R2 TO SAVE ACC DATA ON INT. REST SAME.
DSPMP:    EQU 63-DSPNO                ; STORAGE AREA OF 7 SEG DECODED VALUE OF DIGIT.
ACTLO:    EQU 00H                     ; THIS ENABLE HARDWARE CHANGES LIKE INV BUFFR OR BUFFR
ACTHI:    EQU 0FFH                    ; COMMON CATHODE OR ANODE DISPLAYS.
DKORA:    EQU ACTLO                   ; DIGIT KATHODE OR ANODE, SEG KATHODE OR ANODE.
SKORA:    EQU ACTHI                   ; XOR FF GIVES DATA INVERTED FROM TABLE VALUE.
BLANK:    EQU 00H                     ; THIS IS LOADED TO SEGMENT MEMORY TO DISPLAY BLANK.
DSPNO:    EQU 9                       ; NO. OF DSPLAY OR 8 BIT LATCHES USED IN PRODUCT 4-16
SEGCD:    EQU 0FH                     ; LOWER NIBBLE OF ACC USED FOR DGT VAL UPPER MASK 0FH
DVMNO:    EQU 4                       ; NUMBER OF DISPLAYS USED IN THE VOLTMETER SECTION.
ALRM1:    EQU 54                      ; STORAGE OF ALARM=1 IF DB =0 AFTER DB UNITS POSITION
ALRM2:    EQU 91                      ; STORAGE OF ALARM=1 IF DB =0 AFTER DB UNITS POSITION
OPSP2:    EQU 106                     ; SP-2 LOC O2 OUTPUT 01000000B (LED) IF OFF 0.
OPSP1:    EQU 105                     ; SP-1 LOC O1 OUTPUT 00100000B (LED) IF OFF 0.
TWOSP:    EQU 34                      ; LOCATION FOR LOOPING TWICE FOR 2SP NO SPARE REGISTERS.
RELAY:    EQU 35                      ; THIS IS A COUNTDOWN TIMER TO DO CNTRL FUNCTIONS.
RLYRT:    EQU 3                       ; EVERY SEC CNTRL IS CALLED TO UPDATE RELAYS.
BLINK:    EQU 77                      ; LOCATION TO INDICATE IF DISPLAY SHOULD BLINK.
TPLMT:    EQU 78                      ; OVERRANGE INDICATION IF > THAN THIS NO Hi.Lt.
BTLMT:    EQU 79                      ; UNDERRANGE INDICATION IF < THAN THIS NO Lo.Lt.
