          MOV R0,#TEMKY                 ; R0 SET TO 112 LOC OF TEMP KEY PRESS.
          MOV A,@R0                     ; READ TEMPKY KEYPRESS AT 112.
          JNZ LOGKY                     ; IF KEY WAS PRESSED IN EXINT LAST 8MS JUMP LOGKY.
          JTF TCNTR                     ; IF COUNTER FLAG SET JUMP TO TCNTR TEST CLEARS FLAG.
          JMP CTIME                     ; IF COUNTER FLAG NOT SET JUMP OVER.
TCNTR:    CALL AD256                    ; CALL ROUTINE AD256 WHICH ADD 256 TO CNTMP.
CTIME:    JF1 LODIT                     ; IF F1  IS SET TO 1 JUMP TO LODIT .
          JMP LOGKY                     ; IF F1 IS ZERO JUMP OVER.
LODIT:    JTF TCNTR                     ; IF COUNTER FLAG SET AFTER STOP COUNT JUMP TO TCNTR.
          CALL ADBYT                    ; CALL ROUTINE ADBYT TO ADD LAST COUNTS TO CNTMP.
          CALL REDSP                    ; IF ACC IS ZERO TIMER IS OUT 180MS CALL SUBROT REDSP.
          CALL MAPIT                    ; ARRANGE DIGIT DISPLAY ETC IN INOUT.
          CALL ARNGE                    ; SET LONGTIME AND ARRANGE FOR RESET.
          SEL MB1                       ; SEL MEMBANK 1.
          CALL MAPAL                    ; ARRANGE ALL OTHER DISPLAY.
          SEL MB0                       ; SEL MEMBANK 0.
          IN A,P1                       ; MOVE INTO ACC VALUE AT P1
          CPL A                         ; INVERT DATA IN ACC.
          ANL A,#IOMSK                  ; F0H MAKES UPPER NIBBLE OF ACC 0000
          JNZ RLYTM                     ; IF KEY IS HELD PRESSED DO NOT SLOW RAMP
          MOV R0,#RAMPS                 ; R0 HAS RAMPS LOC 111 THIS ROTINE INC IT BY 10.
          MOV R4,#6                     ; R4 HAS NO OF TIMES RAMPS TO INC EVERY 300MS.
SLWIT:    MOV A,@R0                     ; READ RAMPS LOCATION WHICH DEC TO RAMP UP INC/DEC KEYS.
          XRL A,#FASTS                  ; XOR INC VALUE WITH FASTS AND TEST.
          JZ RLYTM                      ; IF ZERO IT HAS REACHED MAX COUNT OF 20 HENCE NO INC.
          INC @R0                       ; IF NOT INC RAMPS LOC BY ONE.
          DJNZ R4,SLWIT                 ; THIS DEC RAMPS LOC BY NO IN R4 AS A BRAKING EFFECT.
RLYTM:    MOV R0,#RELAY                 ; SET R0 TO CNTRL DELAY LOACATION 35.
          MOV A,@R0                     ; READ TIMING.
          DEC A                         ; DECREMENT BY 1.
          JZ RELYC                      ; IF TIME UP CALL CNTRL
          MOV @R0,A                     ; WRITE DECREMENTED TIME TO LOC 35.
          JMP LOGKY                     ; JUMP OVER AS TIMER STILL ON.
RELYC:    MOV @R0,#RLYRT                ; RELOAD TIMER.
          MOV R0,#TEMKY                 ; R0 SET TO 112 LOC OF TEMP KEY PRESS.
          MOV A,@R0                     ; READ TEMPKY KEYPRESS AT 112.
          JNZ LOGKY                     ; IF KEY WAS PRESSED IN EXINT LAST 8MS JUMP LOGKY.
          CALL CNTRL                    ; CALL CNTRL ROUTINE TO TURN RLS ON OR OFF.
                                        ;
LOGKY:    MOV R0,#TIMES                 ; TIMES ADDR LOADED TO R0.
          MOV A,@R0                     ; READ BALANCE TIMES OF 30MS.
          JZ INKBD                      ; IF TIME UP ZERO JUMP TO READ KEYBORD EVERY 30MS.
          JMP ENDKY                     ; IF NOT ZERO WAIT.
INKBD:    CALL KBDIN                    ; CALL KBDIN SUBROT IF PRESS VALID SETS R3 AND LD KEYPR
ENDKY:    MOV R0,#TEMKY                 ; R0 SET TO 112 LOC OF TEMP KEY PRESS.
          MOV @R0,#0                    ; RESET TEMKY TO WORK ON OTHER ROUTINES.
KEYDT:    MOV A,R3                      ; READ R3 CONTAINS 1 FOR KEYVALID 0 FOR NO KEY INPUT.
          JNZ ONKEY                     ; IF KEY PRESS VALID REACT.
          JMP ILOOP                     ; IF NOT GO BACK TO ILOOP.
ONKEY:    CALL REACT                    ; CALL REACT SUBROUTINE TO READ KEYPR AND DO THE REQ
          CALL MAPIT                    ; DISPLAY DIGIT DISPLAY IN INOUT.
          MOV R1,#RAMPS                 ; SET R1 TO RAMPS TO SEE IF RAMPING IS BEING DONE.
          MOV A,@R1                     ; READ RAMPS.
          XRL A,#FASTS                  ; COMPARE WITH DEFAULT FASTS WHEN RAMP IS NOT DONE Z.
          JNZ ILOOP                     ; IF NOT ZERO JUMPOVER.
          SEL MB1                       ; SEL MEMBANK 1.
          CALL MAPAL                    ; ARRANGE LED ETC IN INOUT.
          SEL MB0                       ; SEL MEMBANK 0.
