          MOV R0,#FLAG2                 ; SET R0 TO FLAG2 WHICH IS 1 IF START CNT HAS TO BE DONE.
          MOV R1,#TICKS                 ; MOVE 103 ADDR FOR DELAY INTO R1.
          MOV A,@R0                     ; READ TO ACC STATUS.
          JNZ STRCN                     ; IF ONE THEN START COUNTING
          JMP TCEXT                     ; IF 0 THEN JUMP OVER.
STRCN:    MOV @R0,#0                    ; RESET STATUS FOR NEXT GATING REFRESH.
PULSE:    ORL P2,#00100000B             ; 4040 RESET TURNED HIGH.
          NOP                           ; DELAY OF 2.5 US.
          NOP                           ; TOTAL DELAY 5US.
          ANL P2,#11011111B             ; 4040 RESET TURNED LOW AFTER 10US.
          MOV @R1,#HICAL                ; AS TICKS LOC HAS COME TO 0 RELOAD IT.
          STRT CNT                      ; START EVENT COUNTING IN SYNC WITH EXT TIMER.
TCEXT:    MOV A,@R1                     ; READ LOCATION 103 TO ACC.
          DEC A                         ; DECREMENT ACC.COUNT DOWN EVERY 6MS TIME FOR ONE LINE D
          JZ FLAGP                      ; JUMP TO FLAG1 IF ACC IS ZERO IE TIME IS UP.
          MOV @R1,A                     ; WRITE BACK DECREMENTED VALUE TO LOC 103.
          JMP ONJOB                     ; JUMP TO END IF STILL TIME IS THERE.
FLAGP:    MOV @R1,#0FFH                 ; AS TICKS LOC HAS COME TO 0 RELOAD IT.
          MOV R0,#GATER                 ; SET R0 TO TICKS*GATER IS GATING PERIOD
          MOV A,@R0                     ; READ VALUE IN RAM.
          DEC A                         ; DECREMENT ACC.COUNT DOWN EVERY 6MS TIME FOR ONE LINE D
          JZ FLAG1                      ; IF 3 CYCLES REACHED FLAGIT.
          MOV @R0,A                     ; WRITE BACK DECREMENTED VALUE TO LOC.
          JMP ONJOB                     ; JUMP TO END IF STILL TIME IS THERE.
FLAG1:    STOP TCNT                     ; STOP COUNTING PULSES FROM LM331.
          CLR F1                        ; CLR F1 TO 0
          CPL F1                        ; COMPLIMENT F1. TO 1
